-------------------------------------------------------------
-- This file is free software; you can redistribute it and/or
-- modify without restriction.  We do ask that you please keep
-- the original author information, and clearly indicate if the
-- software has been modified.
--
-- This software is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty
-- of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
--
-- As a special exception, if other files instantiate generics from
-- this unit, or you link this unit with other files to produce an
-- executable, this unit does not by itself cause the resulting
-- executable to be covered by the GNU General Public License.
-- This exception does not however invalidate any other reasons
-- why the executable file might be covered by the GNU Public
-- License.
-------------------------------------------------------------
package body mcc is

   -- Returns the Natural'Image of Item without leading space
   function Img (Item : Integer) return String is
      X : constant String := Integer'Image (Item);
   begin
      if X (X'First) = ' ' then
         return X (X'First + 1 .. X'Last);
      else
         return X;
      end if;
   end Img;

   function Pad (Text : String; Width : Natural) return String is
      subtype Result_Type is String (1 .. Width);
      Result : Result_Type := (others => ' ');
      Length_Copied : Natural;
   begin
      if Text'Length <= Width then
         Length_Copied := Text'Length;
      else
         Length_Copied := Width;
      end if;
      Result (1 .. Length_Copied) :=
         Text (Text'First .. Text'First + Length_Copied - 1);
      return Result;
   end Pad;

end mcc;

