---------------------------------------------------------------
--
-- RAPID - Rapid Ada Portable Interface Designer
--
-- gui-widget-typed_object.adb
-- Description :
--  Abstract base class for widgets with an optional Ada
--  variable and type
--
-- RAPID is free software; you can redistribute it and/or
-- modify it without restriction.  However, we ask that you
-- please retain the original author information, and clearly
-- indicate if it has been modified.
--
-- RAPID is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty
-- of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
--
-- As a special exception, if other files instantiate generics from
-- this unit, or you link this unit with other files to produce an
-- executable, this unit does not by itself cause the resulting
-- executable to be covered by the GNU General Public License.
-- This exception does not however invalidate any other reasons
-- why the executable file might be covered by the GNU Public
-- License.
--
-- Copyright (C) 2010, OM Kellogg <okellogg@users.sourceforge.net>
---------------------------------------------------------------------

with Generate_Helpers;

package body gui.Widget.Typed_Object is

   procedure Generate_Action_Context_Clause (Widget : in Object) is
   begin
      if Widget.Data_Item /= null and then Widget.Data_Item.all /= "" then
         Generate_Helpers.Generate_With_For_FQN (Widget.Data_Item.all);
      end if;
      if Widget.Data_Type /= null and then Widget.Data_Type.all /= "" then
         Generate_Helpers.Generate_With_For_FQN (Widget.Data_Type.all);
      end if;
   end Generate_Action_Context_Clause;

end gui.Widget.Typed_Object;

